﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace XmlTree
{
    public partial class XmlForm : Form
    {
        public XmlForm()
        {
            InitializeComponent();
        }

        private void showStatus(string s)
        {
            statusLabel.Text = s;
        }

        private void showInfo (string s)
        {
            textBox.AppendText (s + "\r\n");
        }

        private void showProperties (object n)
        {
            propertyGrid.SelectedObject = n;
        }

        private void runButton_Click(object sender, EventArgs e)
        {
            // readSimpleXml("c:\\work\\data.xml");
            // openSimpleXml("c:\\work\\data.xml");
            readDom ("c:\\work\\data.xml");
        }

        private void readDom (string filePath)
        {
            XmlDocument doc = new XmlDocument();
            doc.Load(filePath);
            showProperties (doc.DocumentElement);
        }

        private XmlTextReader g = null;

        private void openSimpleXml (string filePath)
        {
            g = new XmlTextReader(filePath);
            g.Read();
            showStatus ("First element");
            showInfo("Element: " + g.Name);
            showProperties(g);
        }

        private void nextButton_Click(object sender, EventArgs e)
        {
            g.Read ();
            showStatus ("Next element");
            showInfo("Element: " + g.Name);
            showProperties(g);
        }

        private void readSimpleXml(string filePath)
        {
            TreeNode current = null;

            // using System.Xml;
            XmlTextReader f = new XmlTextReader(filePath);
            while (f.Read())
            {
                if (f.NodeType == XmlNodeType.Element)
                {
                    TreeNode n = new TreeNode();
                    n.Text = f.Name;
                    if (current == null)
                        treeView.Nodes.Add(n);
                    else
                        current.Nodes.Add(n);
                    current = n;

                    if (f.HasAttributes)
                    {
                        f.MoveToFirstAttribute();
                        for (int i = 0; i < f.AttributeCount; i++)
                        {

                            TreeNode a = new TreeNode();
                            a.Text = "Attribute: " + f.Name + "=" + f.Value;
                            current.Nodes.Add(a);
                            f.MoveToNextAttribute();
                        }
                        f.MoveToElement();
                    }
                    if (f.IsEmptyElement)
                        current = current.Parent;
                }
                else if (f.NodeType == XmlNodeType.EndElement)
                {
                    current = current.Parent;
                }
                else if (f.NodeType == XmlNodeType.Text)
                {
                    TreeNode n = new TreeNode();
                    n.Text = f.Value;
                    current.Nodes.Add(n);
                }
            }
        }


    }
}
